
diff --git a/configure.ac b/configure.ac
index 935151f..975b691 100644
--- a/configure.ac
+++ b/configure.ac
@@ -49,13 +49,9 @@ case $host in
 *mingw*)
        WINDOWS=yes
        MINGW=yes
-# ASIO doesn't build yet with the autotools setup. We need to figure out how
-#        to make the final linking phase use g++
-#              asio=yes
+       asio=yes
        portaudio=yes
        CFLAGS="$CFLAGS -O6 -funroll-loops -fomit-frame-pointer"
-# ASIO is a C++ library, so if its included, then use g++ to build
-       CC=g++
        EXTERNAL_CFLAGS="-mms-bitfields"
        EXTERNAL_LDFLAGS="-s -shared -Wl,--enable-auto-import -lpd"
        EXTERNAL_EXTENSION=dll


diff --git a/src/Makefile.am b/src/Makefile.am
index b85f726..28fba7a 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -85,6 +85,10 @@ endif

 # ASIO needs to go after PORTAUDIO in order for it to link properly
 if ASIO
+# automake hack to force linking with g++
+SUBDIRS = ../asio
+# Dummy C++ source to cause C++ linking.
+nodist_EXTRA_pd_SOURCES = dummy.cxx
 pd_LDADD += ../asio/libasio.la
 endif

@@ -138,7 +142,6 @@ if MINGW
 pd_CFLAGS += -DWISHAPP='"wish85.exe"' -DMSW #kludge, MSW should be _WIN32
 pdsend_CFLAGS += -DMSW #kludge, should use _WIN32
 pdreceive_CFLAGS += -DMSW #kludge, should use _WIN32
-bin_PROGRAMS += pd-watchdog
 endif

 etags: TAGS

diff --git a/extra/Makefile.am b/extra/Makefile.am
index 766073d..6f0e731 100644
--- a/extra/Makefile.am
+++ b/extra/Makefile.am
@@ -1,6 +1,9 @@
-SUBDIRS=bonk~ choice expr~ fiddle~ loop~ lrshift~ pd~ pique sigmund~ stdout
+SUBDIRS=bonk~ choice expr~ fiddle~ loop~ lrshift~ pique sigmund~ stdout

-DIST_SUBDIRS=$(SUBDIRS)
+if !WINDOWS
+SUBDIRS += pd~
+endif
+DIST_SUBDIRS=$(SUBDIRS) pd~

 PATCHES    =complex-mod~.pd      hilbert~.pd      rev1-final.pd rev1~.pd rev1-s
 HELPPATCHES=complex-mod~-help.pd hilbert~-help.pd rev1~-help.pd

